<!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml"><head><title></title><meta charset="UTF-8"></meta><meta name="generator" content="Hovercraft! 1.0 http://regebro.github.com/hovercraft"></meta><link rel="stylesheet" href="css/hovercraft.css" media="all"></link><link rel="stylesheet" href="css/impressConsole.css" media="all"></link><link rel="stylesheet" href="css/highlight.css" media="all"></link><script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        showProcessingMessages: false,
        messageStyle: "none",
        TeX : { extensions : ['color.js'] }
      });
    </script></head><body class="impress-not-supported"><div id="impress" data-transition-duration="2000"><div class="step step-level-1" step="0" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="0" data-y="0" data-z="0"><h1 id="hacking-python-class">Hacking python class</h1><h2 id="what-is-a-class">What is a class?</h2><h3 id="a-name-to-refer-the-class-object-employee">1. A name to refer the class object: <em>Employee</em></h3><h3 id="a-list-of-parent-class-objects-person-worker">2. A list of parent class objects: <em>(Person, Worker)</em></h3><h3 id="a-collection-of-attributes-public-value-fake-private-attribute-private-attribute">3. A collection of attributes: <em>[public_value, _fake_private_attribute, __private_attribute]</em></h3><h3 id="a-collection-of-methods-instance-method-class-method-static-method-builtin-method">4. A collection of methods: <em>[instance_method, class_method, static_method, builtin_method]</em></h3><h3 id="class-inheritance-resolution-mro">5. Class inheritance resolution: <em>mro</em></h3><h3 id="class-design-patterns-is-a-has-a-proxy">6. Class design patterns: <em>[is-a, has-a, proxy]</em></h3><h3 id="class-from-scratch-type-classname-supers-attributes">7. Class from scratch: <em>[type(classname, (supers,), attributes)]</em></h3></div><div class="step step-level-1" step="1" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="1600" data-y="0" data-z="0"><h1 id="a-simple-python-class-demo">A simple python class demo</h1><pre class="highlight code python"><span class="k">class</span> <span class="nc">Employee</span><span class="p">:</span>

    <span class="c1"># declared class attributes</span>
    <span class="n">employee_count</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">employee_position_count</span> <span class="o">=</span> <span class="p">{}</span>

    <span class="c1"># A fake private attribute by python convention</span>
    <span class="n">_some_private_value</span><span class="o">=</span><span class="s1">'some private value'</span>

    <span class="c1"># declared some real private attribute, which can not access by instance/class directly</span>
    <span class="n">__private_value</span> <span class="o">=</span> <span class="s1">'private'</span>

    <span class="vm">__slots__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">'name'</span><span class="p">,</span> <span class="s1">'age'</span><span class="p">,</span> <span class="s1">'position'</span><span class="p">,</span> <span class="s1">'_value'</span><span class="p">]</span> <span class="c1"># A python limited attribute access protocol</span>

    <span class="k">def</span> <span class="fm">__new__</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span> <span class="c1"># Where create the instance object(self)</span>
        <span class="k">return</span> <span class="nb">object</span><span class="o">.</span><span class="fm">__new__</span><span class="p">(</span><span class="bp">cls</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="bp">None</span><span class="p">,</span> <span class="n">age</span><span class="p">:</span> <span class="nb">int</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="n">position</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="bp">None</span><span class="p">):</span>

        <span class="c1"># Instance's attributes</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">age</span> <span class="o">=</span> <span class="n">age</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">position</span> <span class="o">=</span> <span class="n">position</span>

        <span class="c1"># Access class's attribute</span>
        <span class="n">Employee</span><span class="o">.</span><span class="n">employee_position_count</span><span class="o">.</span><span class="n">setdefault</span><span class="p">(</span><span class="n">position</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
        <span class="n">Employee</span><span class="o">.</span><span class="n">employee_position_count</span><span class="p">[</span><span class="n">position</span><span class="p">]</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="n">Employee</span><span class="o">.</span><span class="n">employee_count</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_value</span> <span class="o">=</span> <span class="s1">'test'</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">value</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> <span class="c1"># a kind of attribute based on **descriptor** protocol</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_value</span>

    <span class="nd">@value.setter</span>
    <span class="k">def</span> <span class="nf">value</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_value</span> <span class="o">=</span> <span class="n">value</span>

    <span class="k">def</span> <span class="nf">work</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> <span class="c1"># instance method</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'{self.name} is working now!'</span><span class="p">)</span>

    <span class="nd">@classmethod</span>
    <span class="k">def</span> <span class="nf">get_employee_count</span><span class="p">(</span><span class="bp">cls</span><span class="p">):</span> <span class="c1"># class method</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Total employee: {cls.employee_count}'</span><span class="p">)</span>

    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_employee_position_count</span><span class="p">(</span><span class="n">position</span><span class="p">:</span> <span class="nb">str</span> <span class="o">=</span> <span class="bp">None</span><span class="p">):</span> <span class="c1"># static method</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">position</span><span class="p">:</span>
            <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Employee in {position}: {Employee.employee_position_count[position]}'</span><span class="p">)</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Employee in {position}: {Employee.employee_position_count.get(position, 0)}'</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span> <span class="c1"># Instance &amp; built-in method</span>
        <span class="k">return</span> <span class="n">f</span><span class="s1">'({self.name} : {self.age} : {self.position})'</span></pre></div><div class="step step-level-1" step="2" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="3200" data-y="0" data-z="0"><h1 id="class-attributes-collection">Class attributes collection</h1><ol><li><dl><dt>Attribute categories</dt><dd><ol><li>public attribute</li><li>private attribute</li><li>class attribute</li><li>descriptor managed attribute</li><li>instance attribute</li></ol></dd></dl></li><li>Class/instance attribute access<blockquote><ol><li>__getattribute__(self, item): Any kind of attribute access</li><li>__getattr__(self, item): Access non-exist(declared) attribute</li><li>__setattr__(self, key, value): Set instance attribute</li><li>descriptor access: get/set/del descriptor managed attribute</li></ol></blockquote></li></ol></div><div class="step step-level-1" step="3" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="4800" data-y="0" data-z="0"><h1 id="work-with-class-s-attribute">Work with class's attribute</h1><pre class="highlight code python"><span class="k">class</span> <span class="nc">NameDescriptor</span><span class="p">:</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before init descriptor attribute value: {value}'</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_value</span> <span class="o">=</span> <span class="n">value</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After init descriptor attribute value: {value}</span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__get__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instance</span><span class="p">,</span> <span class="n">klass</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before getting attribute in descriptor: &lt;{self.__class__.__name__}&gt;.__get__'</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_value</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After getting attribute in descriptor: &lt;{self.__class__.__name__}&gt;.__get__</span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span>

    <span class="k">def</span> <span class="fm">__set__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instance</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before setting attribute in descriptor: &lt;{self.__class__.__name__}&gt;.__set__'</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_value</span> <span class="o">=</span> <span class="n">value</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After setting attribute in descriptor: &lt;{self.__class__.__name__}&gt;.__set__</span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>

<span class="k">class</span> <span class="nc">EmployeeAttributeDemo</span><span class="p">:</span>

    <span class="n">public_value</span> <span class="o">=</span> <span class="s1">'public'</span>
    <span class="n">_fake_private_value</span> <span class="o">=</span> <span class="s1">'fake private value'</span>  <span class="c1"># python convention private attribute</span>
    <span class="n">__real_private_value</span> <span class="o">=</span> <span class="s1">'not really a private value'</span>  <span class="c1"># real private attribute(which is not really private)</span>
    <span class="n">name</span> <span class="o">=</span> <span class="n">NameDescriptor</span><span class="p">(</span><span class="s1">'alice'</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">instance_value</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">instance_value</span> <span class="o">=</span> <span class="n">instance_value</span>

    <span class="k">def</span> <span class="fm">__setattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before setting value of &lt;{key}&gt; =&gt; &lt;{value}&gt; in __setattr__'</span><span class="p">)</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">EmployeeAttributeDemo</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__setattr__</span><span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After setting value of &lt;{key}&gt; =&gt; &lt;{value}&gt; in __setattr__ </span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>

    <span class="k">def</span> <span class="fm">__getattr__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before getting value of &lt;{item}&gt; in __getattr__'</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">item</span> <span class="o">==</span> <span class="s1">'age'</span><span class="p">:</span> <span class="k">return</span> <span class="mi">25</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">super</span><span class="p">(</span><span class="n">EmployeeAttributeDemo</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__getattr__</span><span class="p">(</span><span class="n">item</span><span class="p">)</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After getting value of &lt;{item}&gt; in __getattr__ </span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span>

    <span class="k">def</span> <span class="fm">__getattribute__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">):</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'Before getting value of &lt;{item}&gt; in __getattribute__'</span><span class="p">)</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">super</span><span class="p">(</span><span class="n">EmployeeAttributeDemo</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__getattribute__</span><span class="p">(</span><span class="n">item</span><span class="p">)</span>
        <span class="k">print</span><span class="p">(</span><span class="n">f</span><span class="s1">'After getting value of &lt;{item}&gt; in __getattribute__</span><span class="se">\n</span><span class="s1">'</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">result</span></pre></div><div class="step step-level-1" step="4" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="6400" data-y="0" data-z="0"><h1 id="class-methods-collection">Class methods collection</h1><h2 id="what-is-a-python-class-method">What is a Python class method ?</h2><p>A class method is a function declared inside the declaration of class object.</p><h2 id="what-is-the-difference-between-method-function">What is the difference between method &amp; function ?</h2><ol><li>A function is declared outside of a class(which does not rely on class)</li><li>A method is declared inside a class (which is relies on class)</li></ol><h2 id="class-method-categories">Class method categories</h2><blockquote><ol><li>Class methods: (<strong>@classmethod</strong>)</li><li>Static methods: (<strong>@staticmethod</strong>)</li><li>Instance methods: method(self, *args, **kwargs)</li><li>built-in methods: (__new__ / __init__)</li></ol></blockquote></div><div class="step step-level-1" step="5" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="8000" data-y="0" data-z="0"><h1 id="class-builtin-methods-overview">Class builtin methods overview</h1><p>Title underline too short.</p><pre class="highlight ">Class builtin methods overview
========================</pre><ol><li>Constructor methods overload(__new__/__init__)</li><li>With context protocol overload(__enter__/__exit__)</li><li>If context protocol overload(__bool__/__len__)</li><li>For loop iteration protocol overload(__next__/__iter__)</li><li>Builtin operator overload(__add__/__iadd__)</li></ol></div><div class="step step-level-1" step="6" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="9600" data-y="0" data-z="0"><h1 id="class-inheritance">Class inheritance</h1><ol><li>Default parent: <strong>object</strong></li><li>Class Methods resolution order</li></ol></div><div class="step step-level-1" step="7" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="11200" data-y="0" data-z="0"><h1 id="class-application-patterns">Class application patterns</h1><p>Title underline too short.</p><pre class="highlight ">Class application patterns
========================</pre><ol><li>Is-a pattern</li><li>Has-a pattern</li><li>Proxy pattern</li></ol></div><div class="step step-level-1" step="8" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="12800" data-y="0" data-z="0"><h1 id="back-to-the-origin">Back to the origin</h1><ol><li>Which elements a class has?</li><li>Create a class object from scratch</li></ol></div><div class="step step-level-1" step="9" data-rotate-x="0" data-rotate-y="0" data-rotate-z="0" data-scale="1" data-x="14400" data-y="0" data-z="0"><h1 id="meta-class-in-brief">Meta class in brief</h1><ol><li>What is a meta class and usage</li><li>A step more into type function</li><li>Create meta class</li></ol></div></div><div id="hovercraft-help" class="hide"><table><tr><th>Space</th><td>Forward</td></tr><tr><th>Right, Down, Page Down</th><td>Next slide</td></tr><tr><th>Left, Up, Page Up</th><td>Previous slide</td></tr><tr><th>G</th><td>Go to slide number</td></tr><tr><th>P</th><td>Open presenter console</td></tr><tr><th>H</th><td>Toggle this help</td></tr></table></div><script type="text/javascript" src="js/impress.js"></script><script type="text/javascript" src="js/impressConsole.js"></script><script type="text/javascript" src="js/hovercraft.js"></script></body></html>